# 2. Un passeig per la interfície

## Finestra d'entrada a l'aplicació

La pantalla d'inici de l'aplicació ens permet realitzar diverses funcions:

* Carregar una assemblea ja creada anteriorment, per a la qual cosa haurem de fer clic dues vegades en la icona de l'assemblea,
* Modificar el nom d'usa assemblea ja creada, fent clic a sobre del nom i modificant el text,
* Crear una nova assemblea, fent clic a la icona "Nou", per a la qual cosa haurem d'indicar el nom de la nova assemblea i escollir una mascota,
* Importar una assemblea creada en altre ordinador, i incorporar-la al conjunt de les nostres assemblees, i finalment
* Eliminar una assemblea ja creada, arrossegant aquesta al poal de fem que hi apareix.

![entrada1](https://raw.githubusercontent.com/joamuran/class-jam/master/llx-help/class-jam/images/entrada1.png)
![entrada2](https://raw.githubusercontent.com/joamuran/class-jam/master/llx-help/class-jam/images/entrada2.png)


<!--img src="./documents/class-jam/images/entrada1.png" width="70%" style="margin:auto;display:block"></img-->
<!--img src="./documents/class-jam/images/entrada2.png" width="70%" style="margin:auto;display:block"></img-->


## Un passeig per la interfície

Una vegada hem escollit obrir una assemblea, o crear-ne una de nova, tindrem a la nostra disposició el tauler en blanc de l'assemblea, amb una aspecte semblant al següent:

<img src="./documents/class-jam/images/principal01.png" width="70%" style="margin:auto;display:block"></img>

Com veiem, tenim a l'esquerra, agrupats tots els components de l'assemblea, i a la part superior dreta, la icona del menú de l'aplicació.

Els components de l'assemblea s'organitzen en forma de graella, i poden fer-se més grans o més menuts. Inicialment, ens apareixeran tal i com els veiem, amb un tamany d'un quadrant de la graella, i aliniats tots en una columna a l'esquerra.

### El mode Assemblea

L'assemblea suporta dos modes de treball: El mode d'edició, per configurar el tauler de l'assemblea i els seus components, i el mode d'assemblea, que serà el que utilitzem a classe amb els alumnes per realitzar l'assemblea.

Ambdós modes de treball presenten un menú principal diferent. En el mode assemblea (per defecte actiu en carregar o crear una assemblea), si fem clic al menú, tenim les següents opcions:

<img src="./documents/class-jam/images/mainmenu.png" width="50%" style="margin:auto;display:block"></img>

* Reinicia l'assemblea: Per "netejar" els components de l'assemblea actual, per tornar a iniciar-la.

* Activa el mode d'edició: Per canviar al mode d'edició de components.

* Guarda l'assemblea, per tal de guardar l'organització i l l'estat actual de l'assemblea.

* Exporta l'assemblea, per tal de crear un fitxer comprimit amb l'assemblea i poder utilitzar-lo en un altre equip.

* Tanca l'assemblea, per tal de tancar l'assemblea actual i carregar-ne una altra.

* Ajuda, per accedir a la documentació de l'aplicació.

Pel que fa als componnts, en aquest mode de treball, podem interactuar amb ells de dos formes diferents:

1. Selecció del valor del component, fent clic sobre el propi component, i que ens obrirà un quadre de diàleg per tal de seleccionar durant l'assemblea el valor del components. Per exemple, si fem clic en el mòdul del dia se la setmana "Quin dia és hui", se'ns mostra el següent diàleg:

<img src="./documents/class-jam/images/principal02.png" width="50%" style="margin:auto;display:block"></img>

Per tal de seleccionar el valor del component, en aquest cas, fem clic a sobre el día de la setmana actual, i el confirmem amb el diàleg següent:

<img src="./documents/class-jam/images/principal03.png" width="50%" style="margin:auto;display:block"></img>

Una vegada confirmat, el component ja queda seleccionat amb aquest valor.

2. Reproducció del component. Per a aquells components que ho permeten i estiguen configurats, quan passem per sobre el component amb el ratolí, observarem una icona per "ampliar" el component. Si fem clic sobre la icona, es mostrarà el valor del component en tota l'aplicació i es reproduirà el so predefinit per al valor què hem triat. Com veurem posteriorment, aquest so podrà consistir en una gravació, un fitxer d'àudio o bé fer que la pròpia assemblea sintetitze en veu el text corresponent. Per altra banda, també podem tindre associat un contingut multimèdia, com puga ser un fitxer d'áudio, de vídeo o un enllaç a Youtube. En cas que el valor del component tinga una acció multimèdia associada, se'ns mostrarà un botó de reproducció a la part de baix de la finestra.

<img src="./documents/class-jam/images/principal04.png" width="50%" style="margin:auto;display:block"></img>

En cas que l'áudio que estiga reproduint-se siga més llarg del que esperàvem, tenim la possibilitat de cancel·lar la reproducció tancant el diàleg de reproducció i fent clic a sobre la icona de l'altaveu que es mostra a la part inferior-esquerra.


### El mode d'Edició

Si entrem al mode d'edició, veurem que la interfície canvia lleugerament: Per una banda, els components es troben marcats amb un altre color i amb les vores ratllades, indicant que aquests es poden moure i redimensionar. Si passem el ratolí per damunt d'algun d'aquests components, veurem com ens apareix una marca a la part inferior dreta del component, indicant que podem canviar les seues dimensions. Cada component té una grandària màxima i mínima possible, en funció de les seues característiques.

En aquest moment, podem moure i redimensionar els components, i observarem com la seua distribució s'adapta per tal que no es superposen uns components i altres.

</img><img src="./documents/class-jam/images/principal05.png" width="70%" style="margin:auto;display:block"></img>

Si ara ens fixem de nou amb les opcions del menú, veurem que aquestes han variat significativament, i ara tenim les següents opcions:

</img><img src="./documents/class-jam/images/principal06.png" width="50%" style="margin:auto;display:block"></img>

* Opcions generals, des d'on podem triar la imatge de fons de l'assemblea, indicar si volem la interfície en majúscules i minúscules i quins són els components amb què volem treballar qfent-los visibles o ocults,
* Passar al mode Assemblea, per tornar a l'assemblea per als alumnes,
* Guardar la configuració de l'assemblea
* Exportar l'assemblea
* Eixir de l'assemblea
* Ajuda

Per tal d'ajustar les opcions generals de l'Assemblea, fem clic a la icona corresponent, i veurem una finestra semblant a aquests:

</img><img src="./documents/class-jam/images/principal07.png" width="70%" style="margin:auto;display:block"></img>

Des d'aquet diàleg podem indicar si volem utilitzar les lletres majúscules o minúscules, modificar el fons, triant-ne un dels que venen per defecte a l'aplicació o pujar-ne un de nou. Al diàleg, també podem indicar els components que volem que apareguen a l'assemblea i els que no, per tal d'ajustar l'assemblea a l'alumne a qui vaja dirigida l'assemblea.

Seguint amb el mode de configuració de l'assemblea, una altra cosa que hi podem realitzar és la configuració individual de cada component. Per a això, haurem de fer doble clic sobre el component en qüestió, de manera que accedim al diàleg de configuració del component. Cada component és diferent, i té les seues particularitats de configuració, tot i que alguns components presenten certes smeblances.

Per veure un exemple, el mòdul de selecció del dia, té un diàleg de configuració semblant a aquest:

<img src="./documents/class-jam/images/principal08.png" width="70%" style="margin:auto;display:block"></img>

En aquest diàleg podem realitzar diferents tasques:

* Mostrar si volem que l'element aparega en el diàleg de selecció en el mode assemblea. Per a això, farem clic a sobre la fila de l'element, i veurem com aquest apareixerà en gris.
* Modificar la imatge que volem per a cada element en particular. Si passem el ratolí per sobre la icona del dia de la setmana, observarem que el cursor canvia, de manera que fent clic en aquest moment, podrem modificar la imatge que es mostrarà per representar un dia en concret.
* Afegir accions per defecte per al component, o per a cadascun dels valors, fent clic a les icones de menú, ubicades a la part superior esquerra del diàleg (per a les opcions comunes a tots els valors del component, en aquest dia per a tots els dies de la setmana), o els ubicats al costat de cada valor, per personalitzar les accions per a cada valor en particular. El diàleg d'accions és semblant a aquest:

<img src="./documents/class-jam/images/principal09.png" width="70%" style="margin:auto;display:block"></img>

En ell podem configurar dos tipus d'accions:

* Les accions en mostrar l'element, per a les quals podem fer que l'assemblea llisca una frase, o que reproduisca un fitxer d'audio, amb la possibilitat de gravar un audio o triar el fitxer de so.
* Les accions en reproduir l'element, és a dir, en fer clic a la icona de reproducció quan estem mostrant l'element. Aci podem inclouire un fitxer d'audio (o gravar-lo), de vídeo o bé un enllaç a Youtube.
